package cz.muni.fi.pb162.hw03.csv.impl;

import cz.muni.fi.pb162.hw03.csv.CsvParser;
import cz.muni.fi.pb162.hw03.csv.CsvReader;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.nio.charset.Charset;
import java.nio.file.Path;
import java.util.List;
import java.util.Map;

import static cz.muni.fi.pb162.hw03.csv.CsvParser.DEFAULT_CHARSET;
import static cz.muni.fi.pb162.hw03.csv.CsvParser.DEFAULT_DELIMITER;

/**
 * Factory class for CSV processing
 */
public final class CsvToolkit{

    private CsvToolkit() {
        // intentionally private to prevent instantiation
    }
    /**
     * Creates instance of {@link CsvParser} with default delimiter and charset
     *
     * @return parser
     */
    public static CsvParser parser() {

        return parser(DEFAULT_DELIMITER, DEFAULT_CHARSET);
    }

    /**
     * Creates instance of {@link CsvParser} with given delimiter
     *
     * @param delimiter value delimiter
     * @param charset character encoding
     * @return parser
     */
    public static CsvParser parser(String delimiter, Charset charset) {
        return new Parser(delimiter, charset);
    }

}
