package cz.muni.fi.pb162.hw03.csv.impl;

import cz.muni.fi.pb162.hw03.csv.CsvParser;
import cz.muni.fi.pb162.hw03.csv.CsvReader;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.nio.charset.Charset;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class Parser implements CsvParser {
    private final String delimiter;
    private final Charset charset;

    public Parser(String delimiter, Charset charset) {
        this.delimiter = delimiter;
        this.charset = charset;
    }

    @Override
    public CsvReader<List<String>> open(Path path) throws IOException {
        return open(new FileInputStream(path.toString()));
    }

    @Override
    public CsvReader<List<String>> open(InputStream is) throws IOException {
        return new Reader(is,charset,delimiter);
    }

    @Override
    public CsvReader<Map<String, String>> openWithHeader(Path path) throws IOException {
        return openWithHeader(new FileInputStream(path.toString()));
    }

    @Override
    public CsvReader<Map<String, String>> openWithHeader(InputStream is) throws IOException {
        return new ReaderWithHeader(is,charset, delimiter);
    }

    @Override
    public List<List<String>> readAll(Path path) throws IOException {
        List res = new ArrayList();
        open(path).forEach(x -> res.add(x));
        return res;
    }

    @Override
    public List<Map<String, String>> readAllWithHeader(Path path) throws IOException {
        List res = new ArrayList();
        openWithHeader(path).forEach(x -> res.add(x));
        return res;
    }
}
